#include "buffer_init.h"

//buffer_Init
void buffer_init()
{
	int i;
	for (i = 0; i < NUM_BUFFERS_L2; i++) {
		switch (i)
		{		
			case 0:
				Buffer2D_IN[i].Data = subFrame1;
				break;
			case 1: 
				Buffer2D_IN[i].Data = subFrame3;
				break;
			case 2: 
				Buffer2D_IN[i].Data = subFrame5;
				break;
			case 3: 
				Buffer2D_IN[i].Data = subFrame7;
				break;	
			case 4: 
				Buffer2D_IN[i].Data = subFrame9;
				break;			
		}
		Buffer2D_IN[i].ElementWidth = TRANSFER_LENGTH;
		Buffer2D_IN[i].XCount = 1716/TRANSFER_LENGTH;
		Buffer2D_IN[i].XModify = TRANSFER_LENGTH;
		Buffer2D_IN[i].YCount = L2NUMROWS;
		Buffer2D_IN[i].YModify = TRANSFER_LENGTH;
		Buffer2D_IN[i].CallbackParameter =&Buffer2D_IN[0];//NULL;
		Buffer2D_IN[i].pNext = &Buffer2D_IN[i+1];
	}
	Buffer2D_IN[NUM_BUFFERS_L1-1].pNext = NULL;
}

void L2Buffer_FullSliceInit(ADI_DMA_2D_TRANSFER * buffer, unsigned char * startaddress)
{
		buffer->StartAddress = startaddress;
		buffer->XCount = 1716/TRANSFER_LENGTH;
		buffer->XModify = TRANSFER_LENGTH;
		buffer->YCount =  1;//L2NUMROWS;
		buffer->YModify = TRANSFER_LENGTH;
}

void L2BufferInit(ADI_DMA_2D_TRANSFER * buffer, unsigned char * startaddress)
{
		buffer->StartAddress = startaddress;
		buffer->XCount = MBCOLS/TRANSFER_LENGTH_2;
		buffer->XModify = TRANSFER_LENGTH_2;
		buffer->YCount =  MBROWS;
		buffer->YModify = 1716-MBCOLS+TRANSFER_LENGTH_2;
}

void L1BufferInit(ADI_DMA_2D_TRANSFER * buffer, unsigned char * startaddress)
{
		buffer->StartAddress = startaddress;
		buffer->XCount = MBCOLS/TRANSFER_LENGTH_2;
		buffer->XModify = 1;//trans_length;
		buffer->YCount =  MBROWS;
		buffer->YModify = 1;//trans_length;
}

void L2Buffer_FullMBInit(ADI_DMA_2D_TRANSFER * buffer, unsigned char * startaddress)
{
		buffer->StartAddress = startaddress;
		buffer->XCount = MBCOLS/TRANSFER_LENGTH;
		buffer->XModify = TRANSFER_LENGTH;
		buffer->YCount =  MBROWS;
		buffer->YModify = 1716-MBCOLS+TRANSFER_LENGTH;
}

void L1Buffer_FullMBInit(ADI_DMA_2D_TRANSFER * buffer, unsigned char * startaddress)
{
		buffer->StartAddress = startaddress;
		buffer->XCount = MBCOLS/TRANSFER_LENGTH;
		buffer->XModify = TRANSFER_LENGTH;
		buffer->YCount =  MBROWS;
		buffer->YModify = TRANSFER_LENGTH;
}

